% convert gtsrb_train.mat and gtsrb_test.mat to binary files to be read from c++

% --- training data ---


% load and shuffle
load('gtsrb_train.mat');
ix = randperm(length(gtsrb_train));
gtsrb_train = gtsrb_train(ix, :);

% output
train_label_fid = fopen("train_label.bin", "w");
train_image_fid = fopen("train_image.bin", "w");

  
  
for k = 1:length(gtsrb_train)
  
  label = gtsrb_train(k, 1);
  image = gtsrb_train(k, 2:end);
  
  % convert back to unsigned ints
  label = uint64(label);
  image = uint8((image - 0.01) / 0.98 * 255);

  % write to files
  fwrite(train_label_fid, label, "uint64");
  fwrite(train_image_fid, image, "uint8");

  if mod(k, 5000) == 0
    fprintf('%d ', k);
  end
  
end

fprintf('%d \n', k);

fclose(train_label_fid);
fclose(train_image_fid);


% --- testing data ---

% load and shuffle
load('gtsrb_test.mat');
ix = randperm(length(gtsrb_test));
gtsrb_train = gtsrb_test(ix, :);

test_label_fid = fopen("test_label.bin", "w");
test_image_fid = fopen("test_image.bin", "w");

for k = 1:length(gtsrb_test)
  
  label = gtsrb_test(k, 1);
  image = gtsrb_test(k, 2:end);
  
  % convert back to unsigned ints
  label = uint64(label);
  image = uint8((image - 0.01) / 0.98 * 255);

  % write to files
  fwrite(test_label_fid, label, "uint64");
  fwrite(test_image_fid, image, "uint8");

  if mod(k, 5000) == 0
    fprintf('%d ', k);
  end
  
end

fprintf('%d \n', k);

fclose(test_label_fid);
fclose(test_image_fid);
  
