% test the neural network (nn) saved as trained_net.mat, show correctly identified signs

% -------------------------------------------------------------------------
% test the performance of the trained net with the test data from gtsrb_test
% (12630 lines, each containing the class index and 900 pixel values)

load('trained_net.mat');
load('gtsrb_test.mat');

fprintf('press enter for next image:\n');
tic;
good_count = 0;
for k = 1:length(gtsrb_test)
  estimate = nn_query_net(net, gtsrb_test(k, 2:end));
  [val, pos] = max(estimate);
  if gtsrb_test(k, 1) == pos - 1
    good_count = good_count + 1;
    clf;
    % test image
    input = gtsrb_test(k, :);
    img = reshape(input(2:end), [30 30])';
    subplot(2,3,1);
    imagesc(img);
    xlabel(sprintf('test(%d, 1) = %d', k, input(1)));
    axis("image");
    colormap("gray");
    % test image truth
    subplot(2,3,2);
    ref = imread(sprintf("signs/%d.jpg", input(1)));
    image(ref);
    axis("image");
    xlabel("truth");
    % recognized as
    subplot(2,3,3);
    ref = imread(sprintf("signs/%d.jpg", pos - 1));
    image(ref);
    axis("image");
    xlabel("recognized as");
    % probabilities
    subplot(2,3, [4:6]);
    bar(estimate);
    pause();
  end
  if mod(k, 5000) == 0
    fprintf('%d ', k);
  end
end
fprintf('%d \n', k);
toc;

fprintf('correct %.2f\n', 100.0 * good_count / length(gtsrb_test));

